clear all;
clc;
mu=0.0005;
N=31;
K=2;%%%%no of users
No=0.1;
Nodb=10*log10(1/No)
%No=N*No;
no_of_bits=50000;
%%%%get signature sequences
load '/home/users/arun/sscdma/project/mseq31primpoly45.mat'
s1=charphase;
load '/home/users/arun/sscdma/project/mseq31primpoly75.mat'
s2=charphase;
%%%%%%%generate the anitpodal sequence
s1=2*s1-1;
s2=2*s2-1;
%%%%%%%normalize energy of signature waveforms
s1=s1/sqrt(sum(s1.*s1));
s2=s2/sqrt(sum(s2.*s2));

A=[1 0;0 1];
rho=sum(s1.*s2);
R=[1 rho;rho,1];
%novector(1:K)=No;
%sigma2Aminus2=diag(novector);
bits=round(rand(K,no_of_bits));
b=2*bits-1;

n=sqrt(No)*randn(K,no_of_bits);
x1(1,1:N)=0;
for i=1:no_of_bits
   transmitted_bits=b(1,i)*s1+b(2,i)*s2;
   y=transmitted_bits+sqrt(No)*randn(1,N);%%received statistic
   zmf=sum(y.*s1);
   z=sum(y.*(s1+x1(i,:)));
   x1(i+1,:)=x1(i,:)-mu*z*(y-zmf*s1);
   x1(i+1,:)=x1(i+1,:)-sum(s1.*x1(i+1,:))*s1;%replace by the orthogonal projection
   %orth(i)=sum(s1.*x1(i+1,:));
   b_hat(i)=sign(z);
   %sir(i)=1/(No*(1+sum(x1(i+1,:).*x1(i+1,:)))+(sum((s1+x1(i+1,:)).*s2))^2);
end
b_hat=(b_hat+ones(1,no_of_bits))/2;
ber1=sum(xor(bits(1,:),b_hat(1,:)))/no_of_bits


%y=(R*A*b + n);
%%%%%%%%%%%theoretical optimum weights
%Wopt=inv(R*A*A*R+No*R)*[1;rho];

%c1=[1,1]';
%mean_squared_error(1)=sum((Wopt-c1).^2)/K;
%c1=c1-mu*(c1'*y(:,1)-b(1,1))*y(:,1);
%w1(1)=c1(1,1);
%w2(1)=c1(2,1);

%for i=2:no_of_bits
   %c1=c1-mu*(0.995)^(i-1)*(c1'*y(:,i)-b(1,i))*y(:,i);%%%variable step size
 %  c1=c1-mu*(c1'*y(:,i)-b(1,i))*y(:,i);%%%%fixed step size
  % w1(i)=c1(1,1);
   %w2(i)=c1(2,1);
   %mean_squared_error(i)=sum((Wopt-c1).^2)/K;
%end

%Wopt
%c1
%figure(3);
%subplot(2,1,1);
%plot(w1);
%subplot(2,1,2);
%plot(w2)
%figure(4)
%plot(mean_squared_error);
%%%%%%%%%%%%calculate the minimum mean square error 

%convert to ones and minu ones
%b_hat=(y+ones(K,no_of_bits))/2;

%ber1=sum(xor(bits(1,:),b_hat(1,:)))/no_of_bits;
%ber2=sum(xor(bits(2,:),b_hat(2,:)))/no_of_bits;
% avg_ber=0.5*(ber1+ber2)