clear all;
clc;
N=31;
K=2;%%%%no of users
No=0.1;
Nodb=10*log10(1/No)
%No=N*No;
no_of_bits=1000;
%%%%get signature sequences
load '/home/users/arun/sscdma/project/mseq31primpoly45.mat'
a1=charphase;
load '/home/users/arun/sscdma/project/mseq31primpoly75.mat'
a2=charphase;
%%%%%%%generate the anitpodal sequence
a1=2*a1-1;
a2=2*a2-1;


%%%%%%%normalize energy of signature waveforms
a1=a1/sqrt(sum(a1.*a1));
a2=a2/sqrt(sum(a2.*a2));

A=[1 0;0 1];
rho=sum(a1.*a2);
R=[1 rho;rho,1];
novector(1:K)=No;
sigma2Aminus2=diag(novector);

bits=round(rand(K,no_of_bits));
b=2*bits-1;
n=sqrt(No)*randn(K,no_of_bits);

y=sign(inv(R+sigma2Aminus2)*(R*A*b + n));
%convert to ones and minu ones
b_hat=(y+ones(K,no_of_bits))/2;

ber1=sum(xor(bits(1,:),b_hat(1,:)))/no_of_bits;
ber2=sum(xor(bits(2,:),b_hat(2,:)))/no_of_bits;
avg_ber=0.5*(ber1+ber2)